VTK: vtkBuffer< ScalarTypeT > Class Template Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkBuffer< ScalarTypeT > Class Template Reference

internal storage class used by vtkSOADataArrayTemplate, vtkAOSDataArrayTemplate, and others. More...

`#include <vtkBuffer.h>`

Inheritance diagram for vtkBuffer< ScalarTypeT >:
[legend]
Collaboration diagram for vtkBuffer< ScalarTypeT >:
[legend]

## Public Types
typedef ScalarTypeT | ScalarType

## Public Member Functions
| vtkTemplateTypeMacro (vtkBuffer< ScalarTypeT >, vtkObject)
ScalarType * | GetBuffer ()
| Access the buffer as a scalar pointer. More...
const ScalarType * | GetBuffer () const
void | SetBuffer (ScalarType *array, vtkIdType size)
| Set the memory buffer that this vtkBuffer object will manage. More...
void | SetMallocFunction (vtkMallocingFunction mallocFunction=malloc)
| Set the malloc function to be used when allocating space inside this object. More...
void | SetReallocFunction (vtkReallocingFunction reallocFunction=realloc)
| Set the realloc function to be used when allocating space inside this object. More...
void | SetFreeFunction (bool noFreeFunction, vtkFreeingFunction deleteFunction=free)
| Set the free function to be used when releasing this object. More...
vtkIdType | GetSize () const
| Return the number of elements the current buffer can hold. More...
bool | Allocate (vtkIdType size)
| Allocate a new buffer that holds size elements. More...
bool | Reallocate (vtkIdType newsize)
| Allocate a new buffer that holds newsize elements. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkTypeBool | IsA (const char *name)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkBuffer< ScalarTypeT > * | New ()
static vtkBuffer< ScalarTypeT > * | ExtendedNew ()
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkBuffer ()
| ~vtkBuffer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
ScalarType * | Pointer
vtkIdType | Size
vtkMallocingFunction | MallocFunction
vtkReallocingFunction | ReallocFunction
vtkFreeingFunction | DeleteFunction
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

### template<class ScalarTypeT>
class vtkBuffer< ScalarTypeT >

internal storage class used by vtkSOADataArrayTemplate, vtkAOSDataArrayTemplate, and others.

vtkBuffer makes it easier to keep data pointers in vtkDataArray subclasses. This is an internal class and not intended for direct use expect when writing new types of vtkDataArray subclasses.

Definition at line 23 of file vtkBuffer.h.

## Member Typedef Documentation

## ◆ ScalarType

template<class ScalarTypeT >

typedef ScalarTypeT vtkBuffer< ScalarTypeT >::ScalarType

Definition at line 27 of file vtkBuffer.h.

## Constructor & Destructor Documentation

## ◆ vtkBuffer()

template<class ScalarTypeT >

vtkBuffer< ScalarTypeT >::vtkBuffer | ( |  | ) |
| inlineprotected

Definition at line 80 of file vtkBuffer.h.

## ◆ ~vtkBuffer()

template<class ScalarTypeT >

vtkBuffer< ScalarTypeT >::~vtkBuffer | ( |  | ) |
| inlineoverrideprotected

Definition at line 89 of file vtkBuffer.h.

## Member Function Documentation

## ◆ vtkTemplateTypeMacro()

template<class ScalarTypeT >

vtkBuffer< ScalarTypeT >::vtkTemplateTypeMacro | ( | vtkBuffer< ScalarTypeT > | ,
|  | vtkObject |
| ) |  |

## ◆ New()

template<class ScalarT >

vtkBuffer< ScalarT > * vtkBuffer< ScalarT >::New
| inlinestatic

Definition at line 103 of file vtkBuffer.h.

## ◆ ExtendedNew()

template<class ScalarT >

vtkBuffer< ScalarT > * vtkBuffer< ScalarT >::ExtendedNew
| inlinestatic

Definition at line 109 of file vtkBuffer.h.

## ◆ GetBuffer() [1/2]

template<class ScalarTypeT >

ScalarType* vtkBuffer< ScalarTypeT >::GetBuffer | ( |  | ) |
| inline

Access the buffer as a scalar pointer.

Definition at line 35 of file vtkBuffer.h.

## ◆ GetBuffer() [2/2]

template<class ScalarTypeT >

const ScalarType* vtkBuffer< ScalarTypeT >::GetBuffer | ( |  | ) | const
| inline

Definition at line 36 of file vtkBuffer.h.

## ◆ SetBuffer()

template<class ScalarTypeT >

void vtkBuffer< ScalarT >::SetBuffer | ( | ScalarType * | array,
|  | vtkIdType | size
| ) |  |

Set the memory buffer that this vtkBuffer object will manage.

array is a pointer to the buffer data and size is the size of the buffer (in number of elements).

Definition at line 117 of file vtkBuffer.h.

## ◆ SetMallocFunction()

template<typename ScalarT >

void vtkBuffer< ScalarT >::SetMallocFunction | ( | vtkMallocingFunction | mallocFunction = `malloc` | ) |

Set the malloc function to be used when allocating space inside this object.

Definition at line 131 of file vtkBuffer.h.

## ◆ SetReallocFunction()

template<typename ScalarT >

void vtkBuffer< ScalarT >::SetReallocFunction | ( | vtkReallocingFunction | reallocFunction = `realloc` | ) |

Set the realloc function to be used when allocating space inside this object.

Definition at line 137 of file vtkBuffer.h.

## ◆ SetFreeFunction()

template<typename ScalarT >

void vtkBuffer< ScalarT >::SetFreeFunction | ( | bool | noFreeFunction,
|  | vtkFreeingFunction | deleteFunction = `free`
| ) |  |

Set the free function to be used when releasing this object.

If noFreeFunction is true, the buffer will not be freed when this vtkBuffer object is deleted or resize – otherwise, deleteFunction will be called to free the buffer

Definition at line 144 of file vtkBuffer.h.

## ◆ GetSize()

template<class ScalarTypeT >

vtkIdType vtkBuffer< ScalarTypeT >::GetSize | ( |  | ) | const
| inline

Return the number of elements the current buffer can hold.

Definition at line 66 of file vtkBuffer.h.

## ◆ Allocate()

template<typename ScalarT >

bool vtkBuffer< ScalarT >::Allocate | ( | vtkIdType | size | ) |

Allocate a new buffer that holds size elements.

Old data is not saved.

Definition at line 158 of file vtkBuffer.h.

## ◆ Reallocate()

template<typename ScalarT >

bool vtkBuffer< ScalarT >::Reallocate | ( | vtkIdType | newsize | ) |

Allocate a new buffer that holds newsize elements.

Old data is preserved.

Definition at line 189 of file vtkBuffer.h.

## Member Data Documentation

## ◆ Pointer

template<class ScalarTypeT >

ScalarType* vtkBuffer< ScalarTypeT >::Pointer
| protected

Definition at line 91 of file vtkBuffer.h.

## ◆ Size

template<class ScalarTypeT >

vtkIdType vtkBuffer< ScalarTypeT >::Size
| protected

Definition at line 92 of file vtkBuffer.h.

## ◆ MallocFunction

template<class ScalarTypeT >

vtkMallocingFunction vtkBuffer< ScalarTypeT >::MallocFunction
| protected

Definition at line 93 of file vtkBuffer.h.

## ◆ ReallocFunction

template<class ScalarTypeT >

vtkReallocingFunction vtkBuffer< ScalarTypeT >::ReallocFunction
| protected

Definition at line 94 of file vtkBuffer.h.

## ◆ DeleteFunction

template<class ScalarTypeT >

vtkFreeingFunction vtkBuffer< ScalarTypeT >::DeleteFunction
| protected

Definition at line 95 of file vtkBuffer.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkBuffer.h